import java.io.*;
import java.lang.Math;
import java.util.*;

// -----------------============== NOTE =============--------------------
// To make changes to "terminal" data (for grammars other than XQuery),
// go to the "Generator.java" file--that is the ONLY file that needs to
// be modified for those purposes; everything else is designed to run
// independently of the grammar being used.
// -----------------=================================--------------------

// ------------------------------
// -=-=-=-=-=- IdNode -=-=-=-=-=-
// ------------------------------

class IdNode extends GrammarNode {

    public IdNode(int lineNum, int colNum, String strVal) {

	myLineNum = lineNum;
	myColNum = colNum;
	myStrVal = strVal;

    } // end constructor

    // ----

    public void unparse(PrintWriter p, int indent) {

	p.print(myStrVal);

    } // end method unparse.

    // ----

    public String toString() {

	return myStrVal;

    } // end method toString.

    // ----

    private int myLineNum;
    private int myColNum;
    private String myStrVal;

} // end class IdNode.
