import java.io.*;
import java.lang.Math;
import java.util.*;

// **********************************************************************
// RecurStat class (helper class for GrammarNode).
// **********************************************************************

class RecurStats {

    public RecurStats() {

	prob = 0.0;
	min = 0;
	max = 0;
	count = 0;
	indicator = '#';

    } // end constructor.

    public double prob;         // Probability that a token will be generated.
    public int min;             // Min number of times to generate a token.
    public int max;             // Max number of times to generate a token.
    public int count;           // Current number token generations thus far.
    public char indicator;	// Actual occur indicator associated with token.
 
} // end class RecurStats.
