import java.io.*;
import java.lang.Math;
import java.util.*;

// -----------------============== NOTE =============--------------------
// To make changes to "terminal" data (for grammars other than XQuery),
// go to the "Generator.java" file--that is the ONLY file that needs to
// be modified for those purposes; everything else is designed to run
// independently of the grammar being used.
// -----------------=================================--------------------

// --------------------------------------
// -=-=-=-=-=- TokenOccurNode -=-=-=-=-=-
// --------------------------------------

class TokenOccurNode extends GrammarNode {

    public TokenOccurNode(char occurVal) {

	myOccur = occurVal;

    } // end constructor

    // ----

    public void unparse(PrintWriter p, int indent) {

	p.print(myOccur);

    } // end method unparse.

    // ----

    public char toChar() {

	return myOccur;

    } // end method toString.

    // ----

    public String toString() {

	return ("" + myOccur + "");

    } // end method toString.

    // ----

    // 1 kid
    char myOccur;

} // end class TokenOccurNode.
