// Note that type "NONE" is reserved; any use of it may result
// in improper typing.

@SUBTYPES_OF attribute ARE stringlit id IdString CDATA .

@Expr ==> USE_TOKEN 0 .
@OrExpr ==> TYPE OP_TABLE .
@AndExpr ==> TYPE OP_TABLE .
@FLWRExpr ==> TYPE OP_TABLE .
@QuantifiedExpr ==> TYPE OP_TABLE .

@TypeSwitchExpr ==> USE_TOKEN 1 .
@IfExpr ==> USE_TOKEN 1 .
@IfExpr_NESTED_1_1 ==> FORCE_TOKEN 2 TO_TYPE bool;
	USE_TOKEN 5 .

@InstanceOfExpr ==> TYPE OP_TABLE .
@CastableExpr ==> TYPE OP_TABLE .
@ComparisonExpr ==> TYPE OP_TABLE .
@RangeExpr ==> TYPE OP_TABLE .

@AdditiveExpr ==> USE_TOKEN 0;
	FORCE_TOKEN 1 TO_TOKEN 0 .
@AdditiveExpr_NESTED_1_1 ==> USE_TOKEN 1 .
@AdditiveExpr_NESTED_2_1 ==> USE_TOKEN 1 .

@MultiplicativeExpr ==> USE_TOKEN 0;
	FORCE_TOKEN 1 TO_TOKEN 0 .
@MultiplicativeExpr_NESTED_1_1 ==> USE_TOKEN 1 .
@MultiplicativeExpr_NESTED_2_1 ==> USE_TOKEN 1 .
@MultiplicativeExpr_NESTED_3_1 ==> USE_TOKEN 1 .
@MultiplicativeExpr_NESTED_4_1 ==> USE_TOKEN 1 .

@UnaryExpr ==> USE_TOKEN 1 .
@UnionExpr ==> TYPE OP_TABLE .
@IntersectExceptExpr ==> TYPE OP_TABLE .

@ValueExpr ==> USE_TOKEN 0 FOR_SYNTAX 5;
	TYPE validate FOR_SYNTAX 1;
	TYPE cast FOR_SYNTAX 2;
	TYPE treat FOR_SYNTAX 3;
	TYPE constructor FOR_SYNTAX 4 .

@PathExpr ==> USE_TOKEN 0 .
@PathExpr_NESTED_1_1 ==> TYPE OP_TABLE .
@PathExpr_NESTED_2_1 ==> USE_TOKEN 1 .

@RelativePathExpr ==> TYPE OP_TABLE .
@RelativePathExpr_NESTED_1_1 ==> USE_TOKEN 1 .
@RelativePathExpr_NESTED_2_1 ==> USE_TOKEN 1 .

@StepExpr ==> USE_TOKEN 0 .

@CaseClause ==> USE_TOKEN 4 .
@PrimaryExpr ==> USE_TOKEN 0 FOR_SYNTAX 1 4;
	TYPE funcCall FOR_SYNTAX 2;
	TYPE var FOR_SYNTAX 3 .

@NodeTest ==> TYPE kind FOR_SYNTAX 1;
	USE_TOKEN 0 FOR_SYNTAX 2 .

@NameTest ==> TYPE generic_id FOR_SYNTAX 1;
	USE_TOKEN 0 FOR_SYNTAX 2 .

@Wildcard ==> TYPE step FOR_SYNTAX 1 2 3;
	USE_TOKEN 0 FOR_SYNTAX 4 .

@ForwardStep ==> USE_TOKEN 0 FOR_SYNTAX 1;
	TYPE step FOR_SYNTAX 2 .
@ForwardStep_NESTED_1_1 ==> USE_TOKEN 1.

@ReverseStep ==> USE_TOKEN 0 FOR_SYNTAX 1;
	TYPE step FOR_SYNTAX 2 .
@ReverseStep_NESTED_1_1 ==> USE_TOKEN 1.

@AbbreviatedForwardStep ==> TYPE step FOR_SYNTAX 1;
	USE_TOKEN 0 FOR_SYNTAX 2 3 .
@AbbreviatedForwardStep_NESTED_2_1 ==> USE_TOKEN 1 .

@Predicates ==> USE_TOKEN 0 .
@Predicates_NESTED_1_1 ==> USE_TOKEN 1.

@Literal ==> TYPE number FOR_SYNTAX 1;
	TYPE stringlit FOR_SYNTAX 2 .

@ParenthesizedExpr ==> USE_TOKEN 1 .

@CDataSection ==> TYPE cdata .

@StringLiteral ==> TYPE stringlit .
