import java.io.*;
import java.util.*;

class OpRow {

   public Integer resultToken;
   public Vector specs;		// of "TokenType".

   // ----

   public OpRow() {

	resultToken = null;
	specs = new Vector();

   } // end Constructor.

   // ----

   public String getResult() {

	TokenType tType;
	Iterator itr = specs.iterator();
	while (itr.hasNext()) {
	    tType = (TokenType)itr.next();
	    if (tType.tokenId == -1) {
	    // then this is the result type; return it as a
	    // a string.
		return tType.typeVal;
	    } // end if.
	} // end while.

	// If we get here, we didn't find the result type
	// (should never happen).
	System.out.println("-=- ERROR: Couldn't find result type" + 
	   " of OpRow: '" + toString() + "'. -=-");
	return null;

   } // end method getResult.

   // ----

   public String toString() {

	return (resultToken.intValue() + "<->" + specs);

   } // end method toString.

} // end class OpRow.
